#include <pthread.h>
#include <stdlib.h>

typedef pthread_mutex_t rt_mutex_t;

rt_mutex_t *mutex_create() {
  pthread_mutex_t *mux = (pthread_mutex_t*) malloc(sizeof(pthread_mutex_t));
  if (mux) {
    if (pthread_mutex_init(mux, NULL) == 0)
      return (rt_mutex_t*) mux;
    free(mux);
  }
  return NULL;
}

void mutex_lock(rt_mutex_t* mux) {
  pthread_mutex_lock((pthread_mutex_t*) mux);
}

void mutex_unlock(rt_mutex_t* mux) {
  pthread_mutex_unlock((pthread_mutex_t*) mux);
}

int mutex_trylock(rt_mutex_t* mux) {
  return (pthread_mutex_trylock((pthread_mutex_t *)mux) == 0) ? 1 : 0;
}

void mutex_free(rt_mutex_t* mux) {
  pthread_mutex_destroy((pthread_mutex_t *) mux);
  free(mux);
}
